interface VElement {
    type: string;
    props: Props;
    children: VNode[];
}
declare type VNode = VElement | string;
declare type Props = Record<string, any>;
interface EditAttribute {
    type: 'attribute';
    path: number[];
    attribute: string;
    hole: string;
}
interface EditText {
    type: 'child';
    path: number[];
    index: number;
    hole: string;
}
declare type Edit = EditAttribute | EditText;
interface Block {
    props: Props;
    edits: Edit[];
    mount: (parent: HTMLElement) => void;
    patch: (newBlock: Block) => void;
}

declare const h: (type: string, props?: Props, ...children: VNode[]) => VElement;
declare const render: (vnode: VNode, edits?: Edit[], path?: number[]) => HTMLElement | Text;
declare const block: (fn: (props: Props) => VNode) => (props: Props) => Block;

export { block, h, render };
